{*******************************************************************}
{*                                                                 *}
{* Program:       R T L T e s t            03.07.98   12.01.99     *}
{*                                                                 *}
{* Test frame for Borland / Turbo Pascal 7.0 Runtime Library       *}
{* replacement Units CRT and DOS under Delphi-4                    *}
{* download:                                                       *}
{* http://www.geocities.com/SiliconValley/Sector/7061/download.htm *}
{*                                                                 *}
{* References:                                                     *}
{*   Zieglersoft (CRT)                                             *}
{*     http://www.zieglersoft.dk/uk.html                           *}
{*     http://www.geocities.com/SiliconValley/Park/4905            *}
{*   Delphi Super Page                                             *}
{*     http://sunsite.icm.edu.pl/delphi/                           *}
{*     http://SunSite.Informatik.RWTH-Aachen.DE/delphi/            *}
{*                                                                 *}
{*******************************************************************}
{$I-}

{$ifdef WIN32}
  unit RTLTEST;         {===== Delphi =====}
  interface
    procedure StartTest;

  implementation
  uses  SysUtils,
        CRT, DOS;       {use Delphi replacement units}

{$else}                 {===== Borland Pascal =====}
  program RTLTest;
  uses  DOS, CRT;       {use Borland-Pascal standard units}

  type  tPoint = record  x,y: integer; end;

  var   lineChars    : word absolute 0:$044A; {line characters}
        charRows     : byte absolute 0:$0484; {screen lines}

  const screenSize   : tPoint = (x:80; y:25);
        inputPiping  : boolean = false;
        outputPiping : boolean = false;

  const BEL=#7;    FF=#12;    CRLF=#13#10;
         BS=#8;    CR=#13;
         LF=#10;  ESC=#27;

  const hex: array[0..15] of char = '0123456789ABCDEF';

  procedure ShowCursor; begin end;
  procedure HideCursor; begin end;
  procedure SetInsertMode (insert: boolean); begin end;
  {---------------------------------------------------------}
  function IntToHex (value: longint; digits: integer): string;
  var   hs: string[8];
  begin
    hs := '';
    if digits > 8 then digits := 8;
    while digits > 0
    do begin
      hs := hex[value and $F] + hs;
      value := value shr 4;
      dec (digits);
    end;
    IntToHex := hs;
  end;

{$endif}

var
  con: text;             {direct output to screen console}

{-------------------------------------------------------------------}
function GetKey: char;
var   k: char;
begin
  k := ReadKey;
  if k = #0
  then begin
    write ('>> ');
    k := ReadKey;
  end;
  write (k, '  <',ord(k),'>  ');
  GetKey := k;
end;

{====================}
{    D O S - Test    }
{====================}

{*******************************************************************}
procedure ShowSystemDate;
var   year,month,day,weekDay: word;
      hour,min,sec,sec100: word;
begin
  GetDate (year, month, day, weekDay);
  GetTime (hour, min, sec, sec100);
  writeln ('system date: ', day:2,'.',month:2,'.',year:2
          ,'  ',hour:2,':',min:2,':',sec:2,',',sec100:2);
end;
{-------------------------------------------------------------------}
procedure GetFlags;
  procedure FlagDisplay (flag: boolean; txt: string);
  begin
    if flag
    then writeln (txt,'yes')
    else writeln (txt,'no');
  end;

var   br, ver: boolean;
begin
  GetCBreak(br);
  GetVerify(ver);
  FlagDisplay ( br, 'Ctrl-Break Checking: ');
  FlagDisplay (ver, 'Verify Checking: ');
end;
{-------------------------------------------------------------------}
procedure TestInfo;
var   ver: word;
      year,month,day,weekDay: word;
      hour,min,sec,sec100: word;
begin
  gotoxy (1,3);
  writeln ('---globalInfo---');
  ver := DosVersion;
  writeln ('dos version: ', IntToHex(lo(ver),2), '.', IntToHex(hi(ver),2));

  writeln;
  GetDate (year, month, day, weekDay);
  GetTime (hour, min, sec, sec100);
  ShowSystemDate;
  SetDate (1999,11,11);
  SetTime (1,2,3,4);
  ShowSystemDate;
  SetDate (year, month, day);
  SetTime (hour, min, sec, sec100);
  ShowSystemDate;

  writeln;
  GetFlags;
  SetCBreak(false);
  SetVerify(false);
  GetFlags;
end;

{*******************************************************************}
procedure TestEnv;
begin
  gotoxy (1,3);
  writeln ('---testenv---');
{
  writeln ('EnvCount=', EnvCount);
  writeln ('EnvStr(1)=', EnvStr(1));
}
  writeln ('COMSPEC=', GetEnv('COMSPEC'));
{  SetEnv ('test','125');}
  writeln ('TEST=',    GetEnv('TEST'));
end;
{*******************************************************************}
procedure SplitName (fullname: string);
var   dir,name,ext: string;
begin
  FSplit (fullname, dir, name, ext);
  writeln (dir,'   ',name,'   ', ext);
end;
{-------------------------------------------------------------------}
procedure ExpandName (filename: string);
var   S: PathStr;
begin
  S := FSearch (filename, GetEnv('PATH'));
  if S = ''
  then WriteLn (filename:12, ' not found')
  else WriteLn (filename:12, ' found as ',FExpand(S));
end;
{-------------------------------------------------------------------}
procedure TestFileName;
begin
  gotoxy (1,3);
  writeln ('--- FSplit test---');
  SplitName ('D:');
  SplitName ('D:\filename');
  SplitName ('D:\path\path\filename.ext');

  writeln (LF,'--- FSearch test---');
  ExpandName ('XCOPY.EXE');
  ExpandName ('SORT.EXE');
  ExpandName ('COMMAND.COM');

  writeln (LF,'--- FExpand test---');
  writeln ('.    -->  ',FExpand('.'));
  writeln ('\    -->  ',FExpand('\'));
  writeln ('..\  -->  ',FExpand('..\'));
end;
{*******************************************************************}
procedure FileFind (wildcard: string; searchAttr: word);
var   f: text;
      sr: searchRec;
      ftime: longint;
      dt: DateTime;
      ioError: integer;
      attr: word;
      attrStr: string[6];
      dir,name,ext: string;
begin
  writeln (CRLF, 'FindFirst/FindNext: ',wildcard);
  FillChar (sr, sizeof(searchRec), 0);
  FSplit (wildcard, dir, name, ext);
  FindFirst (wildcard, searchAttr, sr);
  while dosError = 0
  do begin
    write (sr.name:12);
    Assign (f, dir + sr.name);
    Reset(f);
    ioError := ioResult;
    GetFTime (f, ftime);
    UnpackTime (ftime, dt);
    GetFAttr (f, attr);
    attrStr := '......';
    if (attr and readOnly)  <> 0 then attrStr[1] := 'R';
    if (attr and hidden)    <> 0 then attrStr[2] := 'H';
    if (attr and sysFile)   <> 0 then attrStr[3] := 'S';
    if (attr and volumeID)  <> 0 then attrStr[4] := 'V';
    if (attr and directory) <> 0 then attrStr[5] := 'D';
    if (attr and archive)   <> 0 then attrStr[6] := 'A';
    if ioError = 0 then close (f);
    with dt
    do writeln ('   ',year:4,'-',month:2,'-',day:2,'  '
                     ,hour:2, ':', min:2, ':', sec:2
                     ,attrstr:10,'   err=',ioError);
    FindNext (sr);
  end;
  {FindClose (sr);}
end;
{-------------------------------------------------------------------}
procedure TestFileFind;
begin
  gotoxy (1,3);
  writeln ('---FindFile test---');
  FileFind ('\*.*', 0);
{  FileFind ('\*.*', anyfile);}
  FileFind (   '*.exe', ReadOnly + Hidden + Archive);
end;

{*******************************************************************}
procedure TestExec;

  procedure doExec (e1,e2: string);
  begin
    writeln ('---> executing "', e1,e2, '"');
    exec (e1, e2);
    writeln ('  DosError=$', IntToHex(dosError,4), LF);
  end;

begin
  gotoxy (1,3);
  writeln ('---testexec---');
  doExec ('c:\xxx\xxx', '');
  doExec ('CMD.EXE /C', 'DIR *.exe');
  doExec ('CMD.EXE /C', 'COPY \*.333');
  doExec ('UNKNOWN aaaa', '');
  doExec ('xcopy','*.333');
end;

{*******************************************************************}
procedure TestInterrupt;
var   i: integer;   vec: pointer;
begin
  gotoxy (1,3);
  writeln ('---test interrupt---');
  for i := 8 to 20
  do begin
    GetIntVec(i, vec);
    writeln (i:3, ': ',IntToHex (longint(vec),8));
  end;
end;

{====================}
{    C R T - Test    }
{====================}

{*******************************************************************}
procedure TestSound;
var i: word;
begin
  for i := 1 to 5
  do begin
    Sound(220*i);
    delay(50);
  end;
  NoSound;
end;
{-------------------------------------------------------------------}
procedure WriteInitValues;
begin
  with screenSize do
  write   (con,'   screen:  ',x,' * ',y);
  writeln (con,'   window: ',lo(windMin), ',', hi(windMin),' .. '
                            ,lo(windMax), ',', hi(windMax));

  write   (con,'   checkBreak=',checkBreak:5);
  write   (con,'   checkEOF=',checkEOF);
  writeln (con,'   checkSnow=',checkSnow);

  write   (con,'   directVideo=',directVideo);
  write   (con,'   textAttr=',textAttr);
  writeln (con,'   lastMode=',lastMode);
  write   (con,'   cursorPos=',whereX:3,whereY:3);
  write   (con,'   inputPiping=',inputPiping);
  writeln (con,'   outputPiping=',outputPiping);
end;
{-------------------------------------------------------------------}
procedure ResetWindow;
begin
  Window (1,1, screenSize.x, screenSize.y);
end;
{-------------------------------------------------------------------}
procedure TestCursor;
begin
  HideCursor;
  write (#13'cursor is invisible,   press key ',BEL); getkey;
  ShowCursor;

  SetInsertMode (false);
  write (#13'cursor overwrite mode, press key ',BEL); getkey;
  SetInsertMode (true);
  write (#13'cursor insert mode,    press key ',BEL); getkey;
end;
{-------------------------------------------------------------------}
procedure TestScreen;
var   yi: integer;
begin
  GotoXY (1,screenSize.y - 15);
  WriteInitValues;
  GotoXY (1,2);
  for yi := 2 to screenSize.y-1 do writeln (con,yi);
  write (con, screenSize.y);
  GotoXY (1,3);
  for yi := 1 to 8 do write (con,'1234567890');
end;
{-------------------------------------------------------------------}
procedure TestWindow;
var   xp,yp: integer;
begin
  ClrScr;
  TestScreen;
  GotoXY (1,1);
  xp := WhereX;
  yp := WhereY;
  GotoXY(10,6);
  write ('starting window test...');
  Window (10,10,70,20);
  TextBackground (green);
  ClrScr;
  writeln ('window test');
  Window (11,11,69,19);
  TextBackground (blue);
  ClrScr;
  TextColor (white);
  write ('window');
  TextBackground(black);
  ClrEol;

  GotoXY (1,2);    write ('line2');
  GotoXY (1,3);    write ('line3');
  GotoXY (1,4);    write ('line4');
  GotoXY (1,3);
  TextBackground(cyan);
  DelLine;
  InsLine;

  GotoXY (1,5);
  LowVideo;   write(' LowVideo');
  HighVideo;  write(' HighVideo');
  NormVideo;  write(' NormVideo');

  GotoXY (40,6);
  TextColor (lightGreen or blink);
  write ('blinktext at 40,24');
  TextColor (lightGreen);
  ResetWindow;
  GotoXY (xp,yp);
  write (' I am back');
  GotoXY (1, screenSize.y-15);
  WriteInitValues;
end;
{-------------------------------------------------------------------}
procedure TestScrolling;
var   xp,yp, yi: integer;
begin
  ClrScr;
  TestScreen;
  xp := WhereX;
  yp := WhereY;
  Window (10,10,70,24);
  TextBackground (yellow);
  TextColor(blue);
  ClrScr;            {nur Fenster lschen}
  writeln ('scroll test (with delay)');
  Window (11,11,69,23);
  TextBackground (red);
  ClrScr;
  TextColor (white);
  for yi := 1 to 20
  do begin
    writeln ('line ',yi:2);
    delay(50);
  end;

  ResetWindow;
  GotoXY (xp,yp);
end;
{-------------------------------------------------------------------}
const hexDisplay: boolean = false;
      lokset: set of char = [#0..#31];
procedure SymDezi;
var x,y, i:integer;
begin
  GotoXY (1,5);
  for x := 1 to 79 do write (#196);
  writeln;
  for y := 0 to 19
  do begin
    for x := 0 to 12
    do begin
      i :=  y * 13 + x;
      if i > 255
      then write ('     ')
      else if char(i) in lokset
      then write ('',i:3,'  ')      
      else write ('',i:3, char(i):2);
    end;
    writeln ('');
  end;
  for x := 1 to 79 do write ('');
  writeln;
end;

{====================}
{   Test Selection   }
{====================}

{*******************************************************************}
procedure Test_DOS_Unit;
var   cb: char;
begin
  ClrScr;
  repeat
    TextColor (yellow);
    TextBackground (magenta);
    GotoXY (1,1);   ClrEol;
    GotoXY (30,1);  writeln (con, '--- DOS-Test ---');
    GotoXY (1, screenSize.y-10);
    NormVideo;
    writeln (con, ' 0: return');
    writeln (con, ' 1: info test');
    writeln (con, ' 2: environment test');
    writeln (con, ' 3: file name test');
    writeln (con, ' 4: file find test');
    writeln (con, ' 5: execution test');
    writeln (con, ' 6: interrupt test');
    write   (con, ' select... ');
    cb := GetKey;
    ClrScr;
    case cb of
      '1': TestInfo;
      '2': TestEnv;
      '3': TestFileName;
      '4': TestFileFind;
      '5': TestExec;
      '6': TestInterrupt;
    end;
  until (cb = '0') or (cb = ESC);
{  EndCRT;}
end;
{*******************************************************************}
procedure Test_CRT_Unit;
var   cb: char;
begin
  ClrScr;
  repeat
    TextColor (yellow);
    TextBackground (magenta);
    GotoXY (1,1);   ClrEol;
    GotoXY (30,1);  writeln (con, '--- CRT-Test ---');
    GotoXY (1, screenSize.y-10);
    NormVideo;
    writeln (con, ' 0: return');
    writeln (con, ' 1: screen test');
    writeln (con, ' 2: window test');
    writeln (con, ' 3: scroll test');
    writeln (con, ' 4: ascii characters');
    writeln (con, ' 8: cursor test');
    writeln (con, ' 9: sound test');
    write   (con, ' select... ');
    cb := GetKey;
    case cb of
      '1': TestScreen;
      '2': TestWindow;
      '3': TestScrolling;
      '4': SymDezi;
      '8': TestCursor;
      '9': TestSound;
    end;
  until (cb = '0') or (cb = ESC);
end;
{*******************************************************************}
procedure StartTest;
var   cb: char;    compiler: string;
begin

{$ifdef WIN32}
    compiler := 'Delphi';
{$else}
    compiler := 'Turbo/Borland Pascal';
{$endif}

{delay (2000);}
  repeat
    ClrScr;
    TextBackground (magenta);  ClrEol;
    GotoXY (10,1);
    writeln (con, '--- RTL_Test: 01/99 --- created with ', compiler,' ---');
    NormVideo;
    writeln (con);
    writeln (con, CRLF, ' 0: quit');
    writeln (con, CRLF, ' 1: test CRT unit');
    writeln (con, CRLF, ' 2: test DOS unit');
    write   (con, CRLF, ' select... ');
    cb := GetKey;
    case cb of
      '1': Test_CRT_Unit;
      '2': Test_DOS_Unit;
    end;
  until (cb = '0') or (cb = ESC);
end;
{*******************************************************************}
begin
  Assign (con, 'CON');
  Rewrite (con);

{$ifndef WIN32}
  screenSize.x := lineChars;
  screenSize.y := charRows + 1;
  inputPiping  := byte(ptr(prefixSeg, $18)^) <> 1;
  if inputPiping                       {Input Piping ?}
  then begin
    assign (input,'');                 {Input = Standard}
    reset (input);
  end;

  outputPiping := byte(ptr(prefixSeg, $19)^) <> 1;
  if outputPiping                      {Output Piping ?}
  then begin
    assign (output,'');                {Output = Standard}
    rewrite (output);
  end;
  StartTest;
{$endif}
end.

