{*******************************************************************}
{*                                                                 *}
{*  Program:       C r t T e s t            03.07.98   20.11.98    *}
{*                                                                 *}
{*  Test frame for                                                 *}
{*  Borland / Turbo Pascal 7.0 Standard CRT unit and               *}
{*  Delphi 3.0 / 4.0 replacement CRT-Unit.                         *}
{*                                                                 *}
{*  References:                                                    *}
{*    Zieglersoft                                                  *}
{*      http://www.zieglersoft.dk/uk.html                          *}
{*      http://www.geocities.com/SiliconValley/Park/4905           *}
{*    Delphi Super Page                                            *}
{*      http://sunsite.icm.edu.pl/delphi/                          *}
{*      http://SunSite.Informatik.RWTH-Aachen.DE/delphi/           *}
{*                                                                 *}
{*******************************************************************}

{$ifdef WIN32}
  unit RTL_TEST;
  interface
    procedure StartTest;

  implementation
  uses  CRT, DOS, TpString;

{$else}
  program CrtTest;   {08.07.98}
  uses  CRT;   {Borland-7 standard CRT-unit}

var   lineChars  :word absolute 0:$044A; {Zeichen je Zeile}
      charRows   :byte absolute 0:$0484; {Spaltenanzahl}

const textlines  :word = 25;
      inputPiping:  boolean = false;
      outputPiping: boolean = false;

const BEL=#7;    FF=#12;    CRLF=#13#10;
       BS=#8;    CR=#13;
       LF=#10;  ESC=#27;

procedure ShowCursor; begin end;
procedure HideCursor; begin end;
procedure SetInsertMode (insert: boolean); begin end;

{$endif}

var   con: text;             {Ausgabe auf Bildschirm}

{*******************************************************************}
procedure TestSound;
var i: word;
begin
  for i := 1 to 5
  do begin
    Sound(220*i);
    delay(50);
  end;
  NoSound;
end;
{-------------------------------------------------------------------}
procedure WriteInitValues;
begin
  with screenSize do
  write   (con,'   screen: ',x,' .. ',y);
  writeln (con,'   window: ',windMin and $FF,',',windMin shr 8,' .. '
                            ,windMax and $FF,',',windMax shr 8);
{
  write   (con,'   checkBreak=',checkBreak);
  write   (con,'   checkEOF=',checkEOF);
  writeln (con,'   checkSnow=',checkSnow);
}
  write   (con,'   directVideo=',directVideo);
  write   (con,'   textAttr=',textAttr);
  writeln (con,'   lastMode=',lastMode);
  write   (con,'   cursorPos=',whereX:3,whereY:3);
  write   (con,'   inputPiping=',inputPiping);
  writeln (con,'   outputPiping=',outputPiping);
end;
{-------------------------------------------------------------------}
function GetKey: char;
var   k: char;
begin
  k := ReadKey;
  if k = #0
  then begin
    write ('>> ');
    k := ReadKey;
  end;
  write ('"',k,'"',ord(k):4,'    ');
  GetKey := k;
end;
{-------------------------------------------------------------------}
procedure ResetWindow;
begin
  Window (1,1, screenSize.x, screenSize.y);
end;
{-------------------------------------------------------------------}
procedure TestCursor;
begin
  HideCursor;
  write (#13'cursor is invisible,   press key ',BEL); getkey;
  ShowCursor;

  SetInsertMode (false);
  write (#13'cursor overwrite mode, press key ',BEL); getkey;
  SetInsertMode (true);
  write (#13'cursor insert mode,    press key ',BEL); getkey;
end;
{-------------------------------------------------------------------}
procedure TestScreen;
var   yi: integer;
begin
  GotoXY (1,screenSize.y-15);
  WriteInitValues;
  GotoXY (1,2);
  for yi := 2 to screenSize.y-1 do writeln (con,yi);
  write (con, screenSize.y);
  GotoXY (1,3);
  for yi := 1 to 8 do write (con,'1234567890');
end;
{-------------------------------------------------------------------}
procedure TestWindow;
var   xp,yp: integer;
begin
  ClrScr;
  TestScreen;
  GotoXY (1,1);
  xp := WhereX;
  yp := WhereY;
  GotoXY(10,6);
  write ('starting window test...');
  Window (10,10,70,20);
  TextBackground (green);
  ClrScr;
  writeln ('window test');
  Window (11,11,69,19);
  TextBackground (blue);
  ClrScr;
  TextColor (white);
  write ('window');
  TextBackground(black);
  ClrEol;

  GotoXY (1,2);    write ('line2');
  GotoXY (1,3);    write ('line3');
  GotoXY (1,4);    write ('line4');
  GotoXY (1,3);
  TextBackground(cyan);
  DelLine;
  InsLine;

  GotoXY (1,5);
  LowVideo;   write(' LowVideo');
  HighVideo;  write(' HighVideo');
  NormVideo;  write(' NormVideo');

  GotoXY (40,6);
  TextColor (lightGreen or blink);
  write ('blinktext at 40,24');
  TextColor (lightGreen);
  ResetWindow;
  GotoXY (xp,yp);
  write (' I am back');
  GotoXY (1, screenSize.y-15);
  WriteInitValues;
end;
{-------------------------------------------------------------------}
procedure TestScrolling;
var   yi,xp,yp: integer;
begin
  ClrScr;
  TestScreen;
  xp := WhereX;
  yp := WhereY;
  Window (10,10,70,24);
  TextBackground (yellow);
  TextColor(blue);
  ClrScr;
  writeln ('scroll test (with delay)');
  Window (11,11,69,23);
  TextBackground (red);
  ClrScr;
  TextColor (white);
  for yi := 1 to 20
  do begin
    writeln ('zeile ',yi:2);
    delay(50);
  end;

  ResetWindow;
  GotoXY (xp,yp);
end;
{-------------------------------------------------------------------}
const hexDisplay: boolean = false;
      lokset: set of char = [#0..#31];
procedure SymDezi;
var x,y, i:integer;
begin
  GotoXY (1,5);
  for x := 1 to 79 do write (#196);
  writeln;
  for y := 0 to 19
  do begin
    for x := 0 to 12
    do begin
      i :=  y * 13 + x;
      if i > 255
      then write ('     ')
      else if char(i) in lokset
      then write ('',i:3,'  ')      
      else write ('',i:3, char(i):2);
    end;
    writeln ('');
  end;
  for x := 1 to 79 do write ('');
  writeln;
end;
{*******************************************************************}
procedure StartTest;
var   cb: char;
begin
  Assign (con, 'CON');
  Rewrite (con);
  TextColor (yellow);
  TextBackground (black);
delay (2000);
  ClrScr;
  TextBackground (magenta);  ClrEol;
  GotoXY (30,1);
  writeln (con, '--- CrtTest: 7/98 ---');
  NormVideo;
  TestScreen;
  repeat
    GotoXY (1, screenSize.y-10);
    NormVideo;
    writeln (con, ' 0: quit');
    writeln (con, ' 1: screen test');
    writeln (con, ' 2: window test');
    writeln (con, ' 3: scroll test');
    writeln (con, ' 4: ascii characters');
    writeln (con, ' 6: dos unit test');
    writeln (con, ' 8: cursor test');
    writeln (con, ' 9: sound test');
    write   (con, ' select... ');
    cb := GetKey;
    case cb of
      '1': TestScreen;
      '2': TestWindow;
      '3': TestScrolling;
      '4': SymDezi;
      '6': DosTest;
      '8': TestCursor;
      '9': TestSound;
    end;

  until (cb = '0') or (cb = #27);
{  EndCRT;}
end;
{*******************************************************************}
{$ifndef WIN32}
begin
  screenSize.y := charRows + 1;
  inputPiping  := byte(ptr(prefixSeg, $18)^) <> 1;
  if inputPiping                       {Input Piping ?}
  then begin
    assign (input,'');                 {Input = Standard}
    reset (input);
  end;

  outputPiping := byte(ptr(prefixSeg, $19)^) <> 1;
  if outputPiping                      {Output Piping ?}
  then begin
    assign (output,'');                {Output = Standard}
    rewrite (output);
  end;
  StartTest;
{$endif}
end.

